//******************************************************************************
// MIDIV[PT[\tgwEx
// sAm[L[^Cr[NX
// (C)2002-2012 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _PIANOROLLKEYTIMEVIEW_H_
#define _PIANOROLLKEYTIMEVIEW_H_

class CPianoRollKeyTimeView : public CSekaijuView {

	DECLARE_DYNCREATE (CPianoRollKeyTimeView)

	//--------------------------------------------------------------------------
	// Agr[g
	//--------------------------------------------------------------------------
protected:
	long m_lCurTime;                    // ݂̕`^C[tick][Tut[]
	long m_lOldTime;                    // O̕`^C[tick][Tut[]
	long m_lOldX;                       // ȌcxW[pixel]
	long m_lOldY1;                      // ȌcyW[pixel]
	long m_lOldY2;                      // ȌcyW[pixel]
	BOOL m_bOldDraw;                    // Oc`悵H
	CPoint m_ptMouseDown;               // }EXꂽƂ̍W
	CPoint m_ptMouseMove;               // }EXꂽƂ̑O̍W
	UINT m_nMouseDownFlags;             // }EXꂽƂ̃tO
	UINT m_nMouseMoveFlags;             // }EXꂽƂ̑ÕtO
	long m_lTempTool;                   // ꎞIȃc[(0`)
	long m_lTempTrackIndex;             // ꎞIȃgbNԍ(0`65535)
	long m_lTempSnap;                   // ꎞIȃXibv^C[tick]
	long m_lTempVelocity;               // ꎞIȃxVeB(0`127)
	long m_lTempDuration;               // ꎞIȉ(0`)[tick]
	long m_lTempOutputPort;             // ꎞIȏo̓|[g(0`15)
	long m_lTempChannel;                // ꎞIȃ`l(0`15)
	long m_lTempKey;                    // ꎞIȉK(0`127)
	long m_lTempTime;                   // ꎞIȃ^C(0`)[tick]
	long m_lTempTimeNoteOn;             // ꎞIȃm[gI^C(0`)[tick]
	long m_lTempNoteDuration;
	MIDITrack* m_pTempTrack;            // ꎞIȃgbNւ̃|C^
	MIDIEvent* m_pTempEvent;            // ꎞIȃCxgւ̃|C^
	MIDIEvent* m_pLastEvent;            // ꎞIȍŌ̃Cxgւ̃|C^
	long m_lTempMode;                   // ꎞIȃ[h
	CPtrArray m_theTempSelectedEventArray;  // ꎞIȑIĂCxg̔z

	//--------------------------------------------------------------------------
	// \zƔj
	//--------------------------------------------------------------------------
public:
	CPianoRollKeyTimeView ();           // RXgN^
	virtual ~CPianoRollKeyTimeView ();  // fXgN^
	
	//--------------------------------------------------------------------------
	// Iy[V
	//--------------------------------------------------------------------------
public:
	virtual CRect GetNoteRect (MIDIEvent* pNoteOnEvent);
	virtual void EraseOldLine (CDC* pDC);
	virtual void DrawCurLine (CDC* pDC);
	virtual BOOL ShowPopupMenu (CPoint ptMenu);

	//--------------------------------------------------------------------------
	// I[o[Ch
	//--------------------------------------------------------------------------
protected:
	virtual void OnPrepareDC (CDC* pDC, CPrintInfo* pInfo);
	virtual void OnDraw (CDC* pDC);
	virtual void OnUpdate (CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL PreCreateWindow (CREATESTRUCT& cs);

	//--------------------------------------------------------------------------
	// bZ[W}bv
	//--------------------------------------------------------------------------
protected:
	afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy ();
	afx_msg void OnTimer (UINT nIDEvent);
	afx_msg void OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnMouseMove (UINT nFlags, CPoint point);
	afx_msg void OnMouseWheel40 (UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()
};

#endif

