//******************************************************************************
// MIDIV[PT[\tgwEx
// ʃgbNXP[r[NX
// (C)2002-2010 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _MUSICALSCORETRACKSCALEVIEW_H_
#define _MUSICALSCORETRACKSCALEVIEW_H_

#include "InplaceEdit.h"

class CMusicalScoreTrackScaleView : public CSekaijuView {
protected:
	DECLARE_DYNCREATE (CMusicalScoreTrackScaleView)

	//--------------------------------------------------------------------------
	// Agr[g
	//--------------------------------------------------------------------------
protected:
	CPoint m_ptMouseDown;               // }EXꂽƂ̍W
	CPoint m_ptMouseMove;               // }EXꂽƂO̍W
	UINT   m_nMouseDownFlags;           // }EXꂽƂ̃tO
	UINT   m_nMouseMoveFlags;           // }EXꂽƂÕtO
	long   m_lDownTrack;                // }EXꂽƂ̎wgbN(0`MAXMIDITRACKNUM-1)
	long   m_lCurTrack;                 // }EXꂽƂ݂̌̎wgbN(0`MAXMIDITRACKNUM-1)
	long   m_lOldTrack;                 // }EXꂽƂ̑O̎wgbN(0`MAXMIDITRACKNUM-1)
	long   m_lOldTime;                  // Õ^C[tick]
	BOOL   m_bSettingCellString;         // Z̕ҏWł邩

	// eLXg{bNX
	CInplaceEdit  m_theTextBox;

	//--------------------------------------------------------------------------
	// \zƔj
	//--------------------------------------------------------------------------
public:
	CMusicalScoreTrackScaleView ();           // RXgN^
	virtual ~CMusicalScoreTrackScaleView ();  // fXgN^

	//--------------------------------------------------------------------------
	// Iy[V
	//--------------------------------------------------------------------------
protected:
	void DrawGClef 
		(CDC* pDC, long x, long y, long rx, long ry);
	void DrawFClef 
		(CDC* pDC, long x, long y, long rx, long ry);
	void DrawFlat 
		(CDC* pDC, long x, long y, long rx, long ry);
	void DrawSharp 
		(CDC* pDC, long x, long y, long rx, long ry);
	void DrawTimeAndKeySignature 
		(CDC* pDC, long lTrackIndex, long lTime);
	
	CString GetCellString (long lTrack);
	BOOL SetCellString (long lTrack, CString strText);
	BOOL IsTextEditing ();
	BOOL BeginTextEditing ();
	BOOL EndTextEditingOK ();
	BOOL EndTextEditingCancel ();
	BOOL MoveTextBox (long lTrackIndex);

	//--------------------------------------------------------------------------
	// I[o[Ch
	//--------------------------------------------------------------------------
public:
	virtual void OnDraw (CDC* pDC);
	virtual void OnPrepareDC (CDC* pDC, CPrintInfo* pInfo = NULL);

	//--------------------------------------------------------------------------
	// bZ[W}bv
	//--------------------------------------------------------------------------
protected:
	afx_msg BOOL OnCreate (LPCREATESTRUCT lpcs);
	afx_msg void OnDestroy ();
	afx_msg void OnKillFocus (CWnd* pNewWnd);
	afx_msg void OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnMouseMove (UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk (UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk (UINT nFlags, CPoint point);
	afx_msg void OnTimer (UINT nIDEvent);
	afx_msg void OnMouseWheel40 (UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP ()
};

#endif

